## descent3 1.6.0~20250615+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)  # For using CMAKE_<LANG>_BYTE_ORDER

# set default cmake build type to Debug (None Debug Release RelWithDebInfo MinSizeRel)
if(NOT CMAKE_BUILD_TYPE AND NOT DEFINED ENV{CMAKE_BUILD_TYPE})
  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "default build type")
endif()

# toolchain setup for vcpkg must be done before the 'project' call
set(USE_VCPKG "DEFAULT" CACHE STRING "Use vcpkg for dependency management. DEFAULT defers to existence of $VCPKG_ROOT environment variable.")
set_property(CACHE USE_VCPKG PROPERTY STRINGS "DEFAULT" "ON" "OFF")

if(NOT USE_VCPKG STREQUAL "OFF")
  if(DEFINED ENV{VCPKG_ROOT})

    if (CMAKE_TOOLCHAIN_FILE)
      cmake_path(ABSOLUTE_PATH CMAKE_TOOLCHAIN_FILE NORMALIZE OUTPUT_VARIABLE VCPKG_CHAINLOAD_TOOLCHAIN_FILE)
    endif()

    set(VCPKG_TOOLCHAIN_FILE "scripts/buildsystems/vcpkg.cmake")
    cmake_path(ABSOLUTE_PATH VCPKG_TOOLCHAIN_FILE BASE_DIRECTORY $ENV{VCPKG_ROOT} NORMALIZE OUTPUT_VARIABLE CMAKE_TOOLCHAIN_FILE)

    if(CMAKE_TOOLCHAIN_FILE STREQUAL VCPKG_CHAINLOAD_TOOLCHAIN_FILE)
      # prevent endless recursion
      unset(VCPKG_CHAINLOAD_TOOLCHAIN_FILE)
    endif()
  elseif(NOT USE_VCPKG STREQUAL "DEFAULT")
    message(WARNING "USE_VCPKG=${USE_VCPKG} but ENV{VCPKG_ROOT} not set; will use system-provided libraries. Did you forget to set VCPKG_ROOT in your environment?")
  endif()
endif()

project(Descent3
  LANGUAGES C CXX
  VERSION 1.6.0
)

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds are not supported. Please run CMake with a different build path.")
endif()

if(POLICY CMP0177) # install() DESTINATION path are normalized
  cmake_policy(SET CMP0177 NEW)
endif()

option(BUILD_TESTING "Enable testing. Requires GTest." OFF)
option(ENABLE_LOGGER "Enable logging to the terminal" OFF)
option(ENABLE_MEM_RTL "Enable Real-time library memory management functions (disable to verbose memory allocations)" ON)
option(FATAL_GL_ERRORS "Check OpenGL calls and raise exceptions on errors." OFF)
option(FORCE_COLORED_OUTPUT "Always produce ANSI-colored compiler warnings/errors (GCC/Clang only; esp. useful with Ninja)." OFF)
option(FORCE_PORTABLE_INSTALL "Install all files into local directory defined by CMAKE_INSTALL_PREFIX" ON)
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  option(BUILD_EDITOR "Build internal editor" OFF)
endif()

set(CODESIGN_IDENTITY "" CACHE STRING "Sets the macOS code signing identity. If set to something besides the empty string, then the dynamic libraries put into the hog files will be signed using this identity.")
function (macos_sign target)
  if(DEFINED CODESIGN_IDENTITY AND NOT "${CODESIGN_IDENTITY}" STREQUAL "")
    message(STATUS "Code signing ${target}")
    add_custom_command(TARGET ${target} POST_BUILD
            COMMAND codesign --verbose --sign "${CODESIGN_IDENTITY}" --force --timestamp --deep -o runtime $<TARGET_FILE:${target}>)
  endif()
endfunction()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if(MSVC)
  add_compile_options(/source-charset:UTF-8 /execution-charset:UTF-8)
else()
  add_compile_options(-finput-charset=UTF-8)
  # Unfortunately, Clang doesn’t support -fexec-charset yet so this next part
  # is GCC only. Luckily, Clang defaults to using UTF-8 for the execution
  # character set [1], so we’re fine. Once Clang gets support for
  # -fexec-charset, we should probably start using it.
  #
  # [1]: <https://discourse.llvm.org/t/rfc-enabling-fexec-charset-support-to-llvm-and-clang-reposting/71512>
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_options(-fexec-charset=UTF-8)
  endif()
endif()

if(FORCE_COLORED_OUTPUT)
  if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    set(CMAKE_COLOR_DIAGNOSTICS ON)
  else()
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
      add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      add_compile_options(-fcolor-diagnostics)
    endif()
  endif()
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
if(FORCE_PORTABLE_INSTALL)
  set(CMAKE_INSTALL_BINDIR ".")
  set(CMAKE_INSTALL_LIBDIR ".")
  set(CMAKE_INSTALL_DATADIR ".")
  set(CMAKE_INSTALL_DOCDIR ".")

  set(D3_DATADIR "${CMAKE_INSTALL_DATADIR}")
else()
  set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/Descent3")
  # On system install files will go into /usr/share/Descent3
  set(D3_DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/Descent3")
endif()

# Get info about multi-config environment
get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
# Properly determine output directory for generated files
if(IS_MULTI_CONFIG)
  set(D3_GENERATED_FILES_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/build/$<CONFIG>")
else ()
  set(D3_GENERATED_FILES_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/build")
endif()

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/installed" CACHE PATH "Default install path" FORCE)
endif()

if(CMAKE_CXX_BYTE_ORDER STREQUAL "BIG_ENDIAN")
  message(STATUS "Big Endian system detected.")
  add_compile_definitions("OUTRAGE_BIG_ENDIAN")
endif()


# 64 bit machines have a different game checksum than 32 bit machines
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  add_definitions(-DCHECKSUM=2273889835UL)
else()
  add_definitions(-DCHECKSUM=2273873307UL)
endif()

if(BUILD_TESTING)
  find_package(GTest REQUIRED)
  enable_testing()
  include(GoogleTest)
  add_subdirectory(tests)
endif()

# Define names for HOG files
if(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  set(HOG_NAME "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(HOG_NAME "osx")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(HOG_NAME "win")
endif()

# rebuild d3_version.h every time
add_custom_target(get_git_hash ALL)

add_custom_command(
  POST_BUILD
  TARGET get_git_hash
  COMMAND ${CMAKE_COMMAND}
    -D SOURCE_DIR=${PROJECT_SOURCE_DIR}
    -D TARGET_DIR=${PROJECT_BINARY_DIR}
    -D PROJECT_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
    -D PROJECT_VERSION_MINOR=${PROJECT_VERSION_MINOR}
    -D PROJECT_VERSION_PATCH=${PROJECT_VERSION_PATCH}
    -P ${PROJECT_SOURCE_DIR}/cmake/CheckGit.cmake
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
)

install(
  FILES CHANGELOG.md USAGE.md README.md BUILD.md LICENSE THIRD_PARTY.md
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  add_compile_options("-Wno-multichar;-Wall")
endif()

find_package(SDL3 REQUIRED CONFIG REQUIRED COMPONENTS SDL3)
find_package(glm REQUIRED)
find_package(httplib QUIET)
if (TARGET httplib::httplib)
  add_library(httplib ALIAS httplib::httplib)
else()
  # Some Linux distributions do not package httplibConfig.cmake, so find the header manually
  find_file(CPP_HTTPLIB_HEADER httplib.h REQUIRED)
  find_library(CPP_HTTPLIB_LIB cpp-httplib QUIET)

  # The target httplib::httplib cannot be created manually, so rename it
  add_library(httplib INTERFACE ${CPP_HTTPLIB_HEADER})

  # And some Linux distributions build httplib as header-only,
  # and some as header+library. What a mess!
  if (NOT ${CPP_HTTPLIB_LIB} STREQUAL "CPP_HTTPLIB_LIB-NOTFOUND")
    target_link_libraries(httplib INTERFACE ${CPP_HTTPLIB_LIB})
  endif ()
endif()
find_package(ZLIB REQUIRED)
find_package(plog REQUIRED)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  message("Building for Linux")
  add_compile_definitions(POSIX __LINUX__ _USE_OGL_ACTIVE_TEXTURES PRIMARY_HOG=\"d3-linux.hog\")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  message("Building for macOS")
  add_compile_definitions(POSIX MACOSX=1 _USE_OGL_ACTIVE_TEXTURES PRIMARY_HOG=\"d3-osx.hog\")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  # Windows.h defines to avoid as many issues as possible.
  add_compile_definitions(WIN32_LEAN_AND_MEAN NOMINMAX NODRAWTEXT NOBITMAP NOMCX NOSERVICE PRIMARY_HOG=\"d3-win.hog\"
          #[[NOGDI]] # We need GDI for now, enable when GDI is actually not needed (or when all windows.h mentions are gone)
  )

  list(APPEND CMAKE_LIBRARY_PATH "lib/win" "lib/win/DirectX/${CMAKE_CXX_COMPILER_ARCHITECTURE_ID}")
  add_compile_options("$<$<AND:$<CONFIG:Debug>,$<COMPILE_LANGUAGE:CXX>>:/EHsc;/RTC1;/W3;/nologo;/c;/Zi;/TP;/errorReport:prompt>")
  add_compile_options("$<$<AND:$<CONFIG:Release>,$<COMPILE_LANGUAGE:CXX>>:/GL;/FD;/EHsc;/W3;/nologo;/c;/Zi;/TP;/errorReport:prompt>")

  add_link_options("/SAFESEH:NO;/NODEFAULTLIB:LIBC")
  add_link_options("$<$<CONFIG:Release>:/LTCG>")

  add_compile_definitions(WIN32 _CRT_SECURE_NO_WARNINGS _CRT_SECURE_NO_DEPRECATE _CRT_NONSTDC_NO_DEPRECATE)

  set(CMAKE_FIND_LIBRARY_PREFIXES "")
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")

  add_compile_definitions(DIRECTINPUT_VERSION=0x0500)
  find_library(DSOUND_LIBRARY NAMES dsound REQUIRED)
  find_library(DINPUT_LIBRARY NAMES dinput REQUIRED)
  find_library(DXGUID_LIBRARY NAMES dxguid REQUIRED)
  find_library(DDRAW_LIBRARY NAMES ddraw REQUIRED)

  if(MSVC AND CMAKE_CXX_SIMULATE_ID STREQUAL "")
    add_compile_options("/we4150")  # deletion of pointer to incomplete type 'type'; no destructor called
#    add_compile_options("/we4305")  # truncation from 'X' to 'Y'
    add_compile_options("/we4474")  # too many arguments passed for format string
    add_compile_options("/we4700")  # uninitialized local variable 'X' used
    add_compile_options("/we4804")  # unsafe use of type 'bool' in operation
    add_compile_options("/we4806")  # unsafe operation: no value of type 'bool' promoted to type 'int' can equal the given constant
    add_compile_options("/we4473")  # not enough arguments passed for format string
    add_compile_options("/we4477")  # format string requires argument of type X but variadic argument Y has type Z
    add_compile_options("/we4715")  # 'function' : not all control paths return a value
    add_compile_options("/we4834")  # discarding return value of function with [[nodiscard]] attribute
  endif()

  add_compile_options("/MP")  # so msbuild builds with multiple processes
endif()

add_compile_definitions($<$<CONFIG:Release>:RELEASE>)
add_compile_definitions($<$<CONFIG:Debug>:_DEBUG>)

if(ENABLE_LOGGER)
  message("Enabling Logging")
  add_compile_definitions(LOGGER)
endif()

if(FATAL_GL_ERRORS)
  message("Raising exceptions on OpenGL errors")
  add_compile_definitions(FATAL_GL_ERRORS)
endif()

include_directories(
  "cfile"   # TODO: Remove after untying all modules
  "ddebug"  # -*-
  "fix"     # -*-
  "lib"     # TODO: Remove after untying all modules
  "linux"   # -*-
  "Descent3"
  $<$<PLATFORM_ID:Windows>:
    "lib/win/DirectX"
    "lib/win"
  >
)

add_subdirectory(third_party)

add_subdirectory(2dlib)
add_subdirectory(AudioEncode)
add_subdirectory(bitmap)
add_subdirectory(cfile)
add_subdirectory(ddebug)
add_subdirectory(linux)
add_subdirectory(ddio)
add_subdirectory(fix)
add_subdirectory(logger)
add_subdirectory(manage)
add_subdirectory(grtext)
add_subdirectory(mem)
add_subdirectory(misc)
add_subdirectory(model)
add_subdirectory(module)
add_subdirectory(music)
add_subdirectory(networking)
add_subdirectory(physics)
add_subdirectory(renderer)
add_subdirectory(rtperformance)
add_subdirectory(sndlib)
add_subdirectory(stream_audio)
add_subdirectory(ui)
add_subdirectory(unzip)
add_subdirectory(vecmat)
add_subdirectory(libmve)
add_subdirectory(md5)

if(BUILD_EDITOR AND CMAKE_SYSTEM_NAME STREQUAL "Windows")
  add_subdirectory(dd_grwin32)
  add_subdirectory(win32)
  add_subdirectory(editor)
endif()

add_subdirectory(Descent3)

if (CMAKE_CROSSCOMPILING)
  find_package(HogMaker REQUIRED)
else()
  add_subdirectory(tools)
endif()

add_subdirectory(netcon)
add_subdirectory(netgames)
add_subdirectory(scripts)

# Packaging stuff
set(CPACK_SOURCE_GENERATOR "TXZ")
set(CPACK_SOURCE_IGNORE_FILES
  ".git/"
  ".github/"
  ".idea"
  build[s]/
  cmake-build-*
  ".*~$"
)

=== 2dlib/CMakeLists.txt ===
set(HEADERS
  gr.h
  lib2d.h
)
set(CPPS
  font.cpp
  hardsurf.cpp
  memsurf.cpp
  pen.cpp
  pentext.cpp
  screen.cpp
  surface.cpp
  viewport.cpp
)

add_library(2dlib STATIC ${HEADERS} ${CPPS})
target_link_libraries(2dlib PRIVATE
  cfile
  ddebug
  logger
  mem
)
target_include_directories(2dlib PUBLIC
  $<BUILD_INTERFACE:
    ${PROJECT_SOURCE_DIR}/2dlib
  >
)

=== AudioEncode/CMakeLists.txt ===
set(HEADERS
  adecode.h
  aencode.h
  audio_encode.h)
set(CPPS
  adecode.cpp
  aencode.cpp
  encoder.cpp
)

add_library(AudioEncode STATIC ${HEADERS} ${CPPS})
target_link_libraries(AudioEncode PRIVATE
  libacm
  logger
)
target_include_directories(AudioEncode PUBLIC
  $<BUILD_INTERFACE:
    ${PROJECT_SOURCE_DIR}/AudioEncode
  >
)

=== Descent3/CMakeLists.txt ===
set(HEADERS
  AIGoal.h
  AIMain.h
  BOA.h
  Briefing.h
  BriefingParse.h
  ConfigItem.h
  CtlCfgElem.h
  D3ForceFeedback.h
  DeathInfo.h
  DllWrappers.h
  Inventory.h
  LoadLevel.h
  Mission.h
  NewPyroGauges.h
  ObjScript.h
  PilotPicsAPI.h
  SmallViews.h
  TelCom.h
  TelComAutoMap.h
  TelComCargo.h
  TelComEffects.h
  TelComEfxStructs.h
  TelComGoals.h
  aiambient.h
  aipath.h
  aistruct.h
  aistruct_external.h
  aiterrain.h
  ambient.h
  args.h
  attach.h
  audiotaunts.h
  bnode.h
  bsp.h
  buddymenu.h
  cinematics.h
  cockpit.h
  config.h
  controls.h
  credits.h
  ctlconfig.h
  ctlconfigtxt.h
  d3movie.h
  d3music.h
  damage.h
  damage_external.h
  deathinfo_external.h
  debuggraph.h
  descent.h
  difficulty.h
  difficulty_external.h
  door.h
  doorway.h
  fireball.h
  fireball_external.h
  game.h
  gamecinematics.h
  gamecinematics_external.h
  gameevent.h
  gamefile.h
  gamefont.h
  gameloop.h
  gamepath.h
  gamesave.h
  gamesequence.h
  gamespy.h
  gamespyutils.h
  gametexture.h
  gauges.h
  help.h
  hotspotmap.h
  hud.h
  init.h
  levelgoal.h
  levelgoal_external.h
  lighting.h
  lightmap_info.h
  list.h
  localization.h
  marker.h
  matcen.h
  matcen_external.h
  menu.h
  mission_download.h
  mmItem.h
  multi.h
  multi_client.h
  multi_dll_mgr.h
  multi_external.h
  multi_save_settings.h
  multi_server.h
  multi_ui.h
  multi_world_state.h
  multisafe.h
  newui.h
  newui_core.h
  object.h
  object_external.h
  object_lighting.h
  objinfo.h
  objinit.h
  osiris_dll.h
  osiris_predefs.h
  osiris_share.h
  pilot.h
  pilot_class.h
  player.h
  player_external.h
  player_external_struct.h
  postrender.h
  powerup.h
  procedurals.h
  program.h
  render.h
  renderobject.h
  resource.h
  robot.h
  robotfire.h
  room.h
  room_external.h
  scorch.h
  screens.h
  ship.h
  slew.h
  soar.h
  soar_helpers.h
  sounds.h
  special_face.h
  spew.h
  splinter.h
  stringtable.h
  subtitles.h
  terrain.h
  trigger.h
  vclip.h
  viseffect.h
  viseffect_external.h
  voice.h
  weapon.h
  weapon_external.h
  weather.h)

set(CPPS
  aiambient.cpp
  AIGoal.cpp
  AImain.cpp
  aipath.cpp
  aiterrain.cpp
  ambient.cpp
  args.cpp
  attach.cpp
  audiotaunts.cpp
  bnode.cpp
  BOA.cpp
  Briefing.cpp
  BriefingParse.cpp
  bsp.cpp
  buddymenu.cpp
  cinematics.cpp
  cockpit.cpp
  config.cpp
  ConfigItem.cpp
  Controls.cpp
  credits.cpp
  CtlCfgElem.cpp
  ctlconfig.cpp
  D3ForceFeedback.cpp
  d3movie.cpp
  d3music.cpp
  damage.cpp
  debuggraph.cpp
  dedicated_server.cpp
  demofile.cpp
  descent.cpp
  difficulty.cpp
  DllWrappers.cpp
  door.cpp
  doorway.cpp
  fireball.cpp
  game.cpp
  Game2DLL.cpp
  GameCheat.cpp
  gamecinematics.cpp
  gameevent.cpp
  gamefile.cpp
  gamefont.cpp
  GameLoop.cpp
  gamepath.cpp
  gamesave.cpp
  gamesequence.cpp
  gamespy.cpp
  gamespyutils.cpp
  gametexture.cpp
  gauges.cpp
  help.cpp
  hotspotmap.cpp
  hud.cpp
  huddisplay.cpp
  hudmessage.cpp
  init.cpp
  Inventory.cpp
  levelgoal.cpp
  lighting.cpp
  lightmap_info.cpp
  list.cpp
  LoadLevel.cpp
  loadstate.cpp
  localization.cpp
  marker.cpp
  matcen.cpp
  megacell.cpp
  menu.cpp
  Mission.cpp
  mission_download.cpp
  mmItem.cpp
  multi.cpp
  multisafe.cpp
  multisafe_server.cpp
  multi_client.cpp
  multi_connect.cpp
  multi_dll_mgr.cpp
  multi_save_setting.cpp
  multi_server.cpp
  multi_ui.cpp
  NewPyroGauges.cpp
  newui.cpp
  newui_core.cpp
  newui_filedlg.cpp
  object.cpp
  object_lighting.cpp
  objinfo.cpp
  ObjInit.cpp
  ObjScript.cpp
  OsirisLoadandBind.cpp
  osiris_predefs.cpp
  pilot.cpp
  PilotPicsAPI.cpp
  pilot_class.cpp
  Player.cpp
  postrender.cpp
  procedurals.cpp
  program.cpp
  render.cpp
  renderobject.cpp
  robotfire.cpp
  room.cpp
  scorch.cpp
  screens.cpp
  ship.cpp
  SLEW.cpp
  SmallViews.cpp
  soar.cpp
  soar_helpers.cpp
  special_face.cpp
  spew.cpp
  splinter.cpp
  subtitles.cpp
  TelCom.cpp
  TelComAutoMap.cpp
  TelComCargo.cpp
  TelComEffects.cpp
  TelcomEffectsRender.cpp
  TelComGoals.cpp
  terrain.cpp
  terrainrender.cpp
  TerrainSearch.cpp
  trigger.cpp
  vclip.cpp
  viseffect.cpp
  voice.cpp
  weapon.cpp
  WeaponFire.cpp
  weather.cpp
  sdlmain.cpp)

if(WIN32)
  set(PLATFORM_LIBS wsock32.lib winmm.lib)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO /NODEFAULTLIB:LIBC")

  set(MANIFEST ${CMAKE_CURRENT_BINARY_DIR}/Descent3.exe.manifest)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Descent3.exe.manifest.in
    ${MANIFEST}
    @ONLY
    NEWLINE_STYLE WIN32
  )
  set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/Descent3.rc)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Descent3.rc.in
    ${RC_FILE}
    @ONLY
    NEWLINE_STYLE WIN32
  )
endif()

configure_file(
  ${CMAKE_SOURCE_DIR}/lib/d3_platform_path.h.in
  ${CMAKE_BINARY_DIR}/lib/d3_platform_path.h
  @ONLY
)

if(UNIX AND NOT APPLE)
  set(PLATFORM_LIBS m ${CMAKE_DL_LIBS})
endif()

if(APPLE)
  set(PLATFORM_LIBS)
  set(CMAKE_EXE_LINKER_FLAGS "-framework IOKit -framework Cocoa -framework OpenGL -framework Carbon")

  # Set app icon
  set(MACOSX_BUNDLE_ICON_FILE Descent3.icns)
  set(D3Icon ${CMAKE_CURRENT_SOURCE_DIR}/Descent3.icns)
  set_source_files_properties(${D3Icon} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
endif()

file(GLOB_RECURSE INCS "../lib/*.h")

add_executable(Descent3 WIN32 MACOSX_BUNDLE ${D3Icon} ${HEADERS} ${CPPS} ${INCS} ${MANIFEST} ${RC_FILE})
target_link_libraries(Descent3 PRIVATE
  SDL3::SDL3
  2dlib
  AudioEncode
  bitmap
  cfile
  ddebug
  ddio
  fix
  grtext
  inetfile
  libmve
  libacm
  linux
  logger
  manage
  mem
  md5
  misc
  model
  module
  music
  networking
  physics
  renderer
  rtperformance
  sndlib
  stream_audio
  ui
  unzip
  vecmat
  ${PLATFORM_LIBS})
target_include_directories(Descent3 PRIVATE ${PROJECT_BINARY_DIR}/lib ${SDL3_INCLUDE_DIRS})
target_link_options(Descent3 PRIVATE $<$<PLATFORM_ID:Windows>:/DEBUG:FULL>)
set_target_properties(Descent3 PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/build")
add_dependencies(Descent3
  get_git_hash
  Direct_TCP_IP_Hog
  Descent3_Online_TCP_IP_Hog
  HogFull
  Parallax_Online_Hog
  anarchy
  coop
  ctf
  entropy
  hoard
  hyperanarchy
  monsterball
  roboanarchy
  tanarchy
)

install(TARGETS Descent3 RUNTIME BUNDLE DESTINATION .)
if(MSVC)
  install(FILES $<TARGET_PDB_FILE:Descent3> DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== cfile/CMakeLists.txt ===
set(HEADERS
  cfile.h
  default_base_directories.h
  hogfile.h
  inffile.h)
set(CPPS
  cfile.cpp
  hogfile.cpp
  inffile.cpp
)

set(DEFAULT_ADDITIONAL_DIRS "" CACHE STRING "A list of directories that Descent 3 will use as read-only base directories.")
string(REPLACE ";" "\",\n  \"" DEFAULT_ADDITIONAL_DIRS_CPP_EXPR "${DEFAULT_ADDITIONAL_DIRS}")
string(PREPEND DEFAULT_ADDITIONAL_DIRS_CPP_EXPR "\"")
string(APPEND DEFAULT_ADDITIONAL_DIRS_CPP_EXPR "\"")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/default_base_directories.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/default_base_directories.h
  @ONLY
)

add_library(cfile STATIC ${HEADERS} ${CPPS})
target_link_libraries(cfile PRIVATE
  ddebug
  ddio
  logger
  mem
  misc
)
target_include_directories(cfile PUBLIC
  $<BUILD_INTERFACE:
    ${PROJECT_SOURCE_DIR}/cfile
  >
  PRIVATE ${CMAKE_CURRENT_BINARY_DIR}   # For default_base_directories.h
)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== ddebug/CMakeLists.txt ===
set(HEADERS
  debug.h
  mono.h
  pserror.h
)
set(CPPS
  debug.cpp
  error.cpp
  $<$<PLATFORM_ID:Darwin,Linux,OpenBSD>:
    lnxdebug.cpp
    lnxmono.cpp
  >
  $<$<PLATFORM_ID:Windows>:
    windebug.cpp
    winmono.cpp
  >
)

add_library(ddebug STATIC ${HEADERS} ${CPPS})
add_dependencies(ddebug get_git_hash)
target_include_directories(ddebug PUBLIC
  $<BUILD_INTERFACE:
  ${PROJECT_SOURCE_DIR}/ddebug
  >
  PRIVATE ${PROJECT_BINARY_DIR}/lib   # For d3_version.h
  ${SDL3_INCLUDE_DIRS}
)
target_link_libraries(ddebug PRIVATE
  $<$<PLATFORM_ID:Windows>:
    mem
    misc
  >
  PUBLIC
  SDL3::SDL3
  logger
)

=== ddio/CMakeLists.txt ===
set(HEADERS
  chrono_timer.h
  ddio.h
  ddio_common.h
  ddio_lnx.h
  controller.h
  sdlcontroller.h
)
set(CPPS
  chrono_timer.cpp
  ddio.cpp
  file.cpp
  key.cpp
  lnxforcefeedback.cpp
  lnxio.cpp
  sdljoy.cpp
  lnxkey.cpp
  lnxkey_null.cpp
  lnxmouse.cpp
  lnxkey_sdl.cpp
  sdlcontroller.cpp
  $<$<PLATFORM_ID:Darwin,Linux,OpenBSD>:
    lnxfile.cpp
  >
  $<$<PLATFORM_ID:Windows>:
    winfile.cpp
  >
)
add_library(ddio STATIC ${HEADERS} ${CPPS})
target_link_libraries(ddio PRIVATE
  SDL3::SDL3
  ddebug
  logger
  mem
)
target_include_directories(ddio PUBLIC
  $<BUILD_INTERFACE:
  ${PROJECT_SOURCE_DIR}/ddio
  >
  ${SDL3_INCLUDE_DIRS}
)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== editor/CMakeLists.txt ===
set(HEADERS
    ../descent3/aiambient.h
    ../descent3/AIGoal.h
    ../descent3/AIMain.h
    ../descent3/aipath.h
    ../descent3/aistruct.h
    ../descent3/aistruct_external.h
    ../descent3/aiterrain.h
    ../descent3/ambient.h
    ../descent3/args.h
    ../descent3/attach.h
    ../descent3/audiotaunts.h
    ../descent3/bnode.h
    ../descent3/BOA.h
    ../descent3/Briefing.h
    ../descent3/BriefingParse.h
    ../descent3/bsp.h
    ../descent3/buddymenu.h
    ../descent3/cinematics.h
    ../descent3/cockpit.h
    ../descent3/config.h
    ../descent3/ConfigItem.h
    ../descent3/controls.h
    ../descent3/credits.h
    ../descent3/CtlCfgElem.h
    ../descent3/ctlconfig.h
    ../descent3/ctlconfigtxt.h
    ../descent3/D3ForceFeedback.h
    ../descent3/damage.h
    ../descent3/damage_external.h
    ../descent3/DeathInfo.h
    ../descent3/deathinfo_external.h
    ../descent3/debuggraph.h
    ../descent3/descent.h
    ../descent3/difficulty.h
    ../descent3/difficulty_external.h
    ../descent3/DllWrappers.h
    ../descent3/door.h
    ../descent3/doorway.h
    ../descent3/fireball.h
    ../descent3/fireball_external.h
    ../descent3/game.h
    ../descent3/gamecinematics.h
    ../descent3/gamecinematics_external.h
    ../descent3/gameevent.h
    ../descent3/gamefile.h
    ../descent3/gamefont.h
    ../descent3/gameloop.h
    ../descent3/gamepath.h
    ../descent3/gamesave.h
    ../descent3/gamesequence.h
    ../descent3/gamespy.h
    ../descent3/gamespyutils.h
    ../descent3/gametexture.h
    ../descent3/gauges.h
    ../descent3/help.h
    ../descent3/hotspotmap.h
    ../descent3/hud.h
    ../descent3/init.h
    ../descent3/Inventory.h
    ../descent3/levelgoal.h
    ../descent3/levelgoal_external.h
    ../descent3/lighting.h
    ../descent3/lightmap_info.h
    ../descent3/list.h
    ../descent3/LoadLevel.h
    ../descent3/localization.h
    ../descent3/marker.h
    ../descent3/matcen.h
    ../descent3/matcen_external.h
    ../descent3/menu.h
    ../descent3/Mission.h
    ../descent3/mission_download.h
    ../descent3/mmItem.h
    ../descent3/multi.h
    ../descent3/multisafe.h
    ../descent3/multi_client.h
    ../descent3/multi_dll_mgr.h
    ../descent3/multi_external.h
    ../descent3/multi_save_settings.h
    ../descent3/multi_server.h
    ../descent3/multi_ui.h
    ../descent3/multi_world_state.h
    ../descent3/NewPyroGauges.h
    ../descent3/newui.h
    ../descent3/newui_core.h
    ../descent3/object.h
    ../descent3/object_external.h
    ../descent3/object_lighting.h
    ../descent3/objinfo.h
    ../descent3/objinit.h
    ../descent3/ObjScript.h
    ../descent3/osiris_dll.h
    ../descent3/osiris_predefs.h
    ../descent3/osiris_share.h
    ../descent3/pilot.h
    ../descent3/PilotPicsAPI.h
    ../descent3/pilot_class.h
    ../descent3/player.h
    ../descent3/player_external.h
    ../descent3/player_external_struct.h
    ../descent3/postrender.h
    ../descent3/powerup.h
    ../descent3/procedurals.h
    ../descent3/program.h
    ../descent3/render.h
    ../descent3/renderobject.h
    ../descent3/resource.h
    ../descent3/robot.h
    ../descent3/robotfire.h
    ../descent3/room.h
    ../descent3/room_external.h
    ../descent3/scorch.h
    ../descent3/screens.h
    ../descent3/ship.h
    ../descent3/slew.h
    ../descent3/SmallViews.h
    ../descent3/soar.h
    ../descent3/soar_helpers.h
    ../descent3/sounds.h
    ../descent3/special_face.h
    ../descent3/spew.h
    ../descent3/splinter.h
    ../descent3/stringtable.h
    ../descent3/subtitles.h
    ../descent3/TelCom.h
    ../descent3/TelComAutoMap.h
    ../descent3/TelComCargo.h
    ../descent3/TelComEffects.h
    ../descent3/TelComEfxStructs.h
    ../descent3/TelComGoals.h
    ../descent3/terrain.h
    ../descent3/trigger.h
    ../descent3/vclip.h
    ../descent3/viseffect.h
    ../descent3/viseffect_external.h
    ../descent3/voice.h
    ../descent3/weapon.h
    ../descent3/weapon_external.h
    ../descent3/weather.h
    AddScriptDialog.h
    AISettingsDlg.h
    AmbientSoundElement.h
    AmbientSoundPattern.h
    AnimStatesDialog.h
    BriefBitmapEdit.h
    BriefButtonEdit.h
    BriefEdit.h
    BriefManage.h
    BriefMissionFlagsDlg.h
    BriefMovieEdit.h
    BriefScreenEdit.h
    BriefSoundEdit.h
    BriefTextEdit.h
    CreateNewScriptDlg.h
    CustDefaultScriptSelect.h
    CustomObjectDialog.h
    d3edit.h
    D3Splash.h
    D3XStringEditor.h
    DallasFlagDlg.h
    DallasGenericPromptDlg.h
    DallasImportDlg.h
    DallasMainDlg.h
    DallasSoundDlg.h
    DallasStrmAudioDlg.h
    DallasTextureDlg.h
    DallasUserTypesDlg.h
    DallasUtilities.h
    DallasVectorPromptDialog.h
    DeathDialog.h
    DoorwayDialog.h
    drawworld.h
    ebnode.h
    EditLineDialog.h
    editor.h
    editorDoc.h
    editorView.h
    editor_lighting.h
    edoors.h
    EPath.h
    Erooms.h
    FilePageAddDlg.h
    FilePageDialog.h
    FloatingKeypadDialog.h
    GenericDeathDialog.h
    GenericLightDialog.h
    GrFontDialog.h
    GrListBox.h
    group.h
    GrWnd.h
    hemicube.h
    HFile.h
    HObject.h
    HogDialog.h
    HRoom.h
    HTexture.h
    HView.h
    IpFrame.h
    KeypadDialog.h
    LevelDialog.h
    LevelInfoDialog.h
    levelkeypad.h
    LightingDialog.h
    LightingStatus.h
    MainFrm.h
    ManageCheckin.h
    matcenkeypad.h
    MegacellDialog.h
    MegacellKeypad.h
    mfc_compatibility.h
    moveworld.h
    ObjCScript.h
    ObjectClipboard.h
    ObjectDialog.h
    ObjectListCombo.h
    ObjectListDialog.h
    ObjectPropertiesDialog.h
    ObjMoveManager.h
    OrphanRemoveDlg.h
    OsirisStatusDlg.h
    PathPadDialog.h
    PhysicsDlg.h
    PictListBox.h
    PlayerWeaponsDialog.h
    PowerupPropDialog.h
    PreferencesDialog.h
    ProceduralDialog.h
    ProgressWnd.h
    PropertyAIDlg.h
    PropertyPhysicsDlg.h
    QuickCompile.h
    radiosity.h
    radscan_leftedge.h
    radscan_rightedge.h
    rad_cast.h
    read3ds.h
    resource.h
    RobotEditWeaponsDialog.h
    roomkeypaddialog.h
    RoomListCombo.h
    RoomUVs.h
    rotateroom.h
    ScriptCompilerAPI.h
    ScriptEditorDlg.h
    ScriptLevelInterface.h
    ScriptMassCompile.h
    ScriptParmDialog.h
    ScriptSelect.h
    ScriptStudio.h
    ScriptSyncDialog.h
    ScriptWizard.h
    selectedroom.h
    SelectRangeDialog.h
    SelManager.h
    SoundListCombo.h
    SoundSourceDialog.h
    SrvrItem.h
    StatusDlg.h
    StdAfx.h
    TableFileEdit.h
    TableFileFilter.h
    TableFileFilterAddDlg.h
    TableFileFilterMng.h
    TableManage.h
    TerrainDialog.h
    TerrainSoundDialog.h
    TextureDialog.h
    TextureGrWnd.h
    TriggerDialog.h
    TriggerListCombo.h
    ViewerPropDlg.h
    VirtualCompilerConfig.h
    WaterProceduralDialog.h
    WireframeGrWnd.h
    WorldObjectsDoorDialog.h
    WorldObjectsGenericDialog.h
    WorldObjectsLightDialog.h
    WorldObjectsPlayerDialog.h
    WorldObjectsPowerupDialog.h
    WorldObjectsRobotDialog.h
    WorldSoundsDialog.h
    WorldTexturesDialog.h
    WorldWeaponsDialog.h
    d3x.h
)

set(SOURCE
    ../descent3/aiambient.cpp
    ../descent3/AIGoal.cpp
    ../descent3/AImain.cpp
    ../descent3/aipath.cpp
    ../descent3/aiterrain.cpp
    ../descent3/ambient.cpp
    ../descent3/args.cpp
    ../descent3/attach.cpp
    ../descent3/audiotaunts.cpp
    ../descent3/bnode.cpp
    ../descent3/BOA.cpp
    ../descent3/Briefing.cpp
    ../descent3/BriefingParse.cpp
    ../descent3/bsp.cpp
    ../descent3/buddymenu.cpp
    ../descent3/cinematics.cpp
    ../descent3/cockpit.cpp
    ../descent3/config.cpp
    ../descent3/ConfigItem.cpp
    ../descent3/Controls.cpp
    ../descent3/credits.cpp
    ../descent3/CtlCfgElem.cpp
    ../descent3/ctlconfig.cpp
    ../descent3/D3ForceFeedback.cpp
    ../Descent3/d3movie.cpp
    ../Descent3/d3music.cpp
    ../descent3/damage.cpp
    ../descent3/debuggraph.cpp
    ../descent3/dedicated_server.cpp
    ../descent3/demofile.cpp
    ../descent3/descent.cpp
    ../descent3/difficulty.cpp
    ../descent3/DllWrappers.cpp
    ../descent3/door.cpp
    ../descent3/doorway.cpp
    ../descent3/fireball.cpp
    ../descent3/game.cpp
    ../descent3/Game2DLL.cpp
    ../descent3/GameCheat.cpp
    ../descent3/gamecinematics.cpp
    ../descent3/gameevent.cpp
    ../descent3/gamefile.cpp
    ../descent3/gamefont.cpp
    ../descent3/GameLoop.cpp
    ../descent3/gamepath.cpp
    ../descent3/gamesave.cpp
    ../descent3/gamesequence.cpp
    ../descent3/gamespy.cpp
    ../descent3/gamespyutils.cpp
    ../descent3/gametexture.cpp
    ../descent3/gauges.cpp
    ../descent3/help.cpp
    ../descent3/hotspotmap.cpp
    ../descent3/hud.cpp
    ../descent3/huddisplay.cpp
    ../descent3/hudmessage.cpp
    ../descent3/init.cpp
    ../descent3/Inventory.cpp
    ../descent3/levelgoal.cpp
    ../descent3/lighting.cpp
    ../descent3/lightmap_info.cpp
    ../descent3/list.cpp
    ../descent3/LoadLevel.cpp
    ../descent3/loadstate.cpp
    ../descent3/localization.cpp
    ../descent3/marker.cpp
    ../descent3/matcen.cpp
    ../descent3/megacell.cpp
    ../descent3/menu.cpp
    ../descent3/Mission.cpp
    ../descent3/mission_download.cpp
    ../descent3/mmItem.cpp
    ../descent3/multi.cpp
    ../descent3/multisafe.cpp
    ../descent3/multisafe_server.cpp
    ../descent3/multi_client.cpp
    ../descent3/multi_connect.cpp
    ../descent3/multi_dll_mgr.cpp
    ../descent3/multi_save_setting.cpp
    ../descent3/multi_server.cpp
    ../descent3/multi_ui.cpp
    ../descent3/NewPyroGauges.cpp
    ../descent3/newui.cpp
    ../descent3/newui_core.cpp
    ../descent3/newui_filedlg.cpp
    ../descent3/object.cpp
    ../descent3/object_lighting.cpp
    ../descent3/objinfo.cpp
    ../descent3/ObjInit.cpp
    ../descent3/ObjScript.cpp
    ../descent3/OsirisLoadandBind.cpp
    ../descent3/osiris_predefs.cpp
    ../descent3/pilot.cpp
    ../descent3/PilotPicsAPI.cpp
    ../descent3/pilot_class.cpp
    ../descent3/Player.cpp
    ../descent3/postrender.cpp
    ../descent3/procedurals.cpp
    ../descent3/program.cpp
    ../descent3/render.cpp
    ../descent3/renderobject.cpp
    ../descent3/robotfire.cpp
    ../descent3/room.cpp
    ../descent3/scorch.cpp
    ../descent3/screens.cpp
    ../descent3/ship.cpp
    ../descent3/SLEW.cpp
    ../descent3/SmallViews.cpp
    ../descent3/soar.cpp
    ../descent3/soar_helpers.cpp
    ../descent3/special_face.cpp
    ../descent3/spew.cpp
    ../descent3/splinter.cpp
    ../descent3/subtitles.cpp
    ../descent3/TelCom.cpp
    ../descent3/TelComAutoMap.cpp
    ../descent3/TelComCargo.cpp
    ../descent3/TelComEffects.cpp
    ../descent3/TelcomEffectsRender.cpp
    ../descent3/TelComGoals.cpp
    ../descent3/terrain.cpp
    ../descent3/terrainrender.cpp
    ../descent3/TerrainSearch.cpp
    ../descent3/trigger.cpp
    ../descent3/vclip.cpp
    ../descent3/viseffect.cpp
    ../descent3/voice.cpp
    ../descent3/weapon.cpp
    ../descent3/WeaponFire.cpp
    ../descent3/weather.cpp
    AddScriptDialog.cpp
    AISettingsDlg.cpp
    AmbientSoundElement.cpp
    AmbientSoundPattern.cpp
    AnimStatesDialog.cpp
    BriefBitmapEdit.cpp
    BriefButtonEdit.cpp
    BriefEdit.cpp
    BriefManage.cpp
    BriefMissionFlagsDlg.cpp
    BriefMovieEdit.cpp
    BriefScreenEdit.cpp
    BriefSoundEdit.cpp
    BriefTextEdit.cpp
    christest.cpp
    CreateNewScriptDlg.cpp
    CustDefaultScriptSelect.cpp
    CustomObjectDialog.cpp
    D3Splash.cpp
    D3XStringEditor.cpp
    DallasFlagDlg.cpp
    DallasGenericPromptDlg.cpp
    DallasImportDlg.cpp
    DallasMainDlg.cpp
    DallasSoundDlg.cpp
    DallasStrmAudioDlg.cpp
    DallasTextureDlg.cpp
    DallasUserTypesDlg.cpp
    DallasUtilities.cpp
    DallasVectorPromptDialog.cpp
    DeathDialog.cpp
    DoorwayDialog.cpp
    drawworld.cpp
    ebnode.cpp
    EditLineDialog.cpp
    editor.cpp
    editorDoc.cpp
    editorView.cpp
    editor_lighting.cpp
    editor_object_lighting.cpp
    edoors.cpp
    EDVARS.cpp
    EPath.cpp
    Erooms.cpp
    FilePageAddDlg.cpp
    FilePageDialog.cpp
    FloatingKeypadDialog.cpp
    gameeditor.cpp
    GenericDeathDialog.cpp
    GenericLightDialog.cpp

=== fix/CMakeLists.txt ===
set(HEADERS
  fix.h)
set(CPPS
  fix.cpp)

add_library(fix STATIC ${HEADERS} ${CPPS})
target_include_directories(fix PUBLIC
  $<BUILD_INTERFACE:
  ${PROJECT_SOURCE_DIR}/fix
  >
)

=== grtext/CMakeLists.txt ===
set(HEADERS
  grtext.h
  grtextlib.h
)
set(CPPS
  grfont.cpp
  grtext.cpp
  textaux.cpp
)

add_library(grtext STATIC ${HEADERS} ${CPPS})
target_link_libraries(grtext PRIVATE
  ddebug
  ddio
  logger
  mem
)
target_include_directories(grtext PUBLIC
  $<BUILD_INTERFACE:
    ${PROJECT_SOURCE_DIR}/grtext
  >
)

=== libmve/CMakeLists.txt ===
set(HEADERS
  decoders.h
  movie_sound.h
  mve_audio.h
  mvelib.h
  sound_interface.h)
set(CPPS
  decoder8.cpp
  decoder16.cpp
  movie_sound.cpp
  mve_audio.cpp
  mvelib.cpp
  mveplay.cpp
)

add_library(libmve STATIC ${HEADERS} ${CPPS})
target_link_libraries(libmve PRIVATE
  ddio
  SDL3::SDL3
)
target_include_directories(libmve PUBLIC
  $<BUILD_INTERFACE:
    ${PROJECT_SOURCE_DIR}/libmve
  >
  ${SDL3_INCLUDE_DIRS}
)

=== linux/CMakeLists.txt ===
set(HEADERS
  lnxapp.h
  registry.h)
set(CPPS
  lnxcon.cpp
  lnxcon_raw.cpp
  lnxapp.cpp
  lnxcon_null.cpp
  lnxdata.cpp
  registry.cpp
)

add_library(linux STATIC ${HEADERS} ${CPPS})
target_link_libraries(linux PRIVATE
  cfile
  logger
)
target_include_directories(linux PUBLIC
  $<BUILD_INTERFACE:
  ${PROJECT_SOURCE_DIR}/linux
  >
  ${PROJECT_BINARY_DIR}/lib
  ${SDL3_INCLUDE_DIRS}
)
target_link_libraries(linux PRIVATE
  ddebug
  ddio
  SDL3::SDL3
)

=== debian/changelog ===
descent3 (1.6.0~20250615+ds-1) experimental; urgency=low

  * New GIT snapshot.
    + Use SDL3
  * d/control: build-depends on libcpp-httplib-dev, libplog-dev and libsdl3-dev

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 05 Oct 2025 11:20:13 +0200

=== debian/control ===
Source: descent3
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13), cmake, libcpp-httplib-dev, libglm-dev, libplog-dev, libsdl3-dev, zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://github.com/DescentDevelopers/Descent3
Vcs-Browser: https://salsa.debian.org/games-team/descent3
Vcs-Git: https://salsa.debian.org/games-team/descent3.git

Package: descent3
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}, game-data-packager-runtime (>= 80), descent3-data (>= 80) | game-data-packager
Description: port of the 1999 classic game Descent 3
 This is the Descent 3 open source engine by Outrage Entertainment.
 .
 In this video game, the player must control a flying ship that has
 a six degrees of freedom movement scheme, allowing the player to move
 and rotate in any 3D direction.
 .
 To make this package useful, you will need the original game data.
 You can install them by using the game-data-packager package.
